/*==========================================================*/
/* Title        :   PubFuncs.h                          */
/* Description  :   PubFuncs.h   definition             */
/* Copyright     :     ENPC Corporation                            */
/* Version        :     V000                                           */
/* Author         :     Zhuo Qingfeng                             */
/* Date            :    Apr.2013                               */
/* Contributor:                                          */
/*==========================================================*/
#ifndef     PUBFUNCS_H

#define     PUBFUNCS_H

//ú
#define     S2U(x)      (*((volatile UINT16*)(&(x))))

#define     MAX2(x,y)   (((x)>=(y))?(x):(y))
#define     MIN2(x,y)   (((x)<=(y))?(x):(y))
#define     SIGN(x)     (((x)<=0)?0:1)
#define     UPDNLMT16(Var,Max,Min)  {(Var)=((Var)>=(Max))?(Max):(Var);(Var)=((Var)<=(Min))?(Min):(Var);}
#define     UPDNLMT32(Var,Max,Min)  {(Var)=((Var)>=(Max))?(Max):(Var);(Var)=((Var)<=(Min))?(Min):(Var);}
#define     FILTER(ik,iVar,lMean)   (((((INT32)(iVar)<<16)-(lMean))>>((ik)+1))+(lMean))   //  74ns
#define     FILTER1(ik,iVar,lMean,Cnt)  (((Cnt) >=1)?(((((INT32)(iVar)<<16)-(lMean))>>((ik)+1))+(lMean)):(lMean)) //ʱ134ns
#define     FILTER0(ik,iVar,lMean,Cnt)  (((Cnt) < 1)?(((((INT32)(iVar)<<16)-(lMean))>>((ik)+1))+(lMean)):(lMean))

extern const int16 i16_SinTab[1030];

class       Class_System;           //0x1101
class       Class_PowCANProtocol;       //0x1301
class       Class_PowCANScheduler;  //0x1201
class       Class_DigitalIO;            //0x1401
class       Class_Switches;         //0x1501
class       Class_Bypass;               //0x1601
class       Class_Inverter;         //0x1701
class       Class_Output;               //0x1801
class       Class_Parallel;             //0x1901
class       Class_DCBus;                //0x1A01
class       Class_InverterAlgorithm;    //0x1B01
class       Class_MonitorInterface;     //0x1C01
class       Class_Load;             //0x1D01
class       Class_InverterControl;      //0x1E01
class       Class_Transfer;         //0x1F01
class       Class_LBS;              //0x2001
class       Class_Service;          //0x2101
class       Class_ECO;              //0x2201
class       Class_FaultRecord;          //0x2301
class       Class_EEPROM;           //0x2401
class       Class_SelfAgingAlgorithm;   //0x2501
class       Class_Debug;                //0x2601
class       Class_FlashUpdate;      //0x2801
class       Class_FPGAFlash;            //0x2901
class       Class_FPGAConfig;           //0x2A01
class       SysCanProtocol;         //0x2B01
class       SysCanApp;              //0x2C01
class       SysCanDataExchg;

extern      Class_System                objSystem;
extern      Class_PowCANProtocol        objPowCANPro;
extern      Class_PowCANScheduler       objPowCANSched;
extern      Class_DigitalIO             objDigitalIO;
extern      Class_Switches              objSwitches;
extern      Class_Bypass                objBypass;
extern      Class_Inverter              objInverter;
extern      Class_Output                objOutput;
extern      Class_Parallel              objParallel;
extern      Class_DCBus                 objDCBus;
extern      Class_InverterAlgorithm     objInvAlg;
extern      Class_MonitorInterface      objMonInterface;
extern      Class_Load                  objLoad;
extern      Class_InverterControl       objInvCtrl;
extern      Class_Transfer              objXfer;
extern      Class_LBS                   objLBS;
extern      Class_Service               objService;
extern      Class_ECO                   objECO;
extern      Class_FaultRecord           objFaultRecord;
extern      Class_EEPROM                objEEPROM;
extern      Class_SelfAgingAlgorithm    objSelfAgingAlg;
extern      Class_Debug                 objDebug;
extern      Class_FlashUpdate           objFlashUpdate;
extern      Class_FPGAFlash             objFPGAFlash;
extern      Class_FPGAConfig            objFPGAConfig;
//-----System CAN ض--------
extern      SysCanProtocol              objProtocol;
extern      SysCanApp                   objSysCanApp;
//ӦòϢ
extern      SysCanDataExchg             objDataExchg;

volatile unsigned long g_bErrFlag = 0;
volatile unsigned long g_ulTxMsgCount = 0;
volatile unsigned long g_ulRxMsgCount = 0;

//---------------------------------------

// :sqrt(x*2^16),xΪеfrom 1 to 1023;ݶΪQ12ʽ
// Q8룬Q12
const INT16 SqrtTab[1026]=
{
    256,256,362,443,512,572,627,677,724,768,
    810,849,887,923,958,991,1024,1056,1086,1116,
    1145,1173,1201,1228,1254,1280,1305,1330,1355,1379,
    1402,1425,1448,1471,1493,1515,1536,1557,1578,1599,
    1619,1639,1659,1679,1698,1717,1736,1755,1774,1792,
    1810,1828,1846,1864,1881,1899,1916,1933,1950,1966,
    1983,1999,2016,2032,2048,2064,2080,2095,2111,2126,
    2142,2157,2172,2187,2202,2217,2232,2246,2261,2275,
    2290,2304,2318,2332,2346,2360,2374,2388,2401,2415,
    2429,2442,2455,2469,2482,2495,2508,2521,2534,2547,
    2560,2573,2585,2598,2611,2623,2636,2648,2660,2673,
    2685,2697,2709,2721,2733,2745,2757,2769,2781,2793,
    2804,2816,2828,2839,2851,2862,2874,2885,2896,2908,
    2919,2930,2941,2952,2963,2974,2985,2996,3007,3018,
    3029,3040,3051,3061,3072,3083,3093,3104,3114,3125,
    3135,3146,3156,3167,3177,3187,3197,3208,3218,3228,
    3238,3248,3258,3268,3278,3288,3298,3308,3318,3328,
    3338,3348,3357,3367,3377,3387,3396,3406,3415,3425,
    3435,3444,3454,3463,3473,3482,3491,3501,3510,3519,
    3529,3538,3547,3556,3566,3575,3584,3593,3602,3611,
    3620,3629,3638,3647,3656,3665,3674,3683,3692,3701,
    3710,3719,3727,3736,3745,3754,3762,3771,3780,3788,
    3797,3806,3814,3823,3831,3840,3849,3857,3866,3874,
    3882,3891,3899,3908,3916,3924,3933,3941,3949,3958,
    3966,3974,3982,3991,3999,4007,4015,4023,4031,4040,
    4048,4056,4064,4072,4080,4088,4096,4104,4112,4120,
    4128,4136,4144,4152,4160,4167,4175,4183,4191,4199,
    4207,4214,4222,4230,4238,4245,4253,4261,4268,4276,
    4284,4291,4299,4307,4314,4322,4329,4337,4344,4352,
    4360,4367,4375,4382,4389,4397,4404,4412,4419,4427,
    4434,4441,4449,4456,4464,4471,4478,4485,4493,4500,
    4507,4515,4522,4529,4536,4544,4551,4558,4565,4572,
    4579,4587,4594,4601,4608,4615,4622,4629,4636,4643,
    4650,4658,4665,4672,4679,4686,4693,4700,4707,4713,
    4720,4727,4734,4741,4748,4755,4762,4769,4776,4782,
    4789,4796,4803,4810,4817,4823,4830,4837,4844,4851,
    4857,4864,4871,4877,4884,4891,4898,4904,4911,4918,
    4924,4931,4938,4944,4951,4957,4964,4971,4977,4984,
    4990,4997,5003,5010,5017,5023,5030,5036,5043,5049,
    5056,5062,5069,5075,5081,5088,5094,5101,5107,5114,
    5120,5126,5133,5139,5146,5152,5158,5165,5171,5177,
    5184,5190,5196,5203,5209,5215,5221,5228,5234,5240,
    5246,5253,5259,5265,5271,5278,5284,5290,5296,5302,
    5309,5315,5321,5327,5333,5339,5345,5352,5358,5364,
    5370,5376,5382,5388,5394,5400,5406,5412,5418,5425,
    5431,5437,5443,5449,5455,5461,5467,5473,5479,5485,
    5491,5497,5503,5508,5514,5520,5526,5532,5538,5544,
    5550,5556,5562,5568,5574,5579,5585,5591,5597,5603,
    5609,5615,5620,5626,5632,5638,5644,5649,5655,5661,
    5667,5673,5678,5684,5690,5696,5701,5707,5713,5719,
    5724,5730,5736,5741,5747,5753,5759,5764,5770,5776,
    5781,5787,5793,5798,5804,5810,5815,5821,5826,5832,
    5838,5843,5849,5855,5860,5866,5871,5877,5882,5888,
    5894,5899,5905,5910,5916,5921,5927,5932,5938,5943,
    5949,5954,5960,5965,5971,5976,5982,5987,5993,5998,
    6004,6009,6015,6020,6026,6031,6036,6042,6047,6053,
    6058,6063,6069,6074,6080,6085,6090,6096,6101,6107,
    6112,6117,6123,6128,6133,6139,6144,6149,6155,6160,
    6165,6171,6176,6181,6187,6192,6197,6202,6208,6213,
    6218,6223,6229,6234,6239,6245,6250,6255,6260,6265,
    6271,6276,6281,6286,6292,6297,6302,6307,6312,6318,
    6323,6328,6333,6338,6343,6349,6354,6359,6364,6369,
    6374,6379,6385,6390,6395,6400,6405,6410,6415,6420,
    6426,6431,6436,6441,6446,6451,6456,6461,6466,6471,
    6476,6481,6486,6492,6497,6502,6507,6512,6517,6522,
    6527,6532,6537,6542,6547,6552,6557,6562,6567,6572,
    6577,6582,6587,6592,6597,6602,6607,6612,6616,6621,
    6626,6631,6636,6641,6646,6651,6656,6661,6666,6671,
    6676,6681,6685,6690,6695,6700,6705,6710,6715,6720,
    6725,6729,6734,6739,6744,6749,6754,6759,6763,6768,
    6773,6778,6783,6788,6792,6797,6802,6807,6812,6817,
    6821,6826,6831,6836,6841,6845,6850,6855,6860,6864,
    6869,6874,6879,6883,6888,6893,6898,6903,6907,6912,
    6917,6921,6926,6931,6936,6940,6945,6950,6955,6959,
    6964,6969,6973,6978,6983,6987,6992,6997,7001,7006,
    7011,7016,7020,7025,7030,7034,7039,7043,7048,7053,
    7057,7062,7067,7071,7076,7081,7085,7090,7094,7099,
    7104,7108,7113,7118,7122,7127,7131,7136,7141,7145,
    7150,7154,7159,7163,7168,7173,7177,7182,7186,7191,
    7195,7200,7204,7209,7214,7218,7223,7227,7232,7236,
    7241,7245,7250,7254,7259,7263,7268,7272,7277,7281,
    7286,7290,7295,7299,7304,7308,7313,7317,7322,7326,
    7331,7335,7340,7344,7349,7353,7357,7362,7366,7371,
    7375,7380,7384,7389,7393,7397,7402,7406,7411,7415,
    7420,7424,7428,7433,7437,7442,7446,7450,7455,7459,
    7464,7468,7472,7477,7481,7486,7490,7494,7499,7503,
    7507,7512,7516,7520,7525,7529,7534,7538,7542,7547,
    7551,7555,7560,7564,7568,7573,7577,7581,7586,7590,
    7594,7599,7603,7607,7611,7616,7620,7624,7629,7633,
    7637,7642,7646,7650,7654,7659,7663,7667,7671,7676,
    7680,7684,7689,7693,7697,7701,7706,7710,7714,7718,
    7723,7727,7731,7735,7740,7744,7748,7752,7756,7761,
    7765,7769,7773,7778,7782,7786,7790,7794,7799,7803,
    7807,7811,7815,7820,7824,7828,7832,7836,7840,7845,
    7849,7853,7857,7861,7865,7870,7874,7878,7882,7886,
    7890,7895,7899,7903,7907,7911,7915,7919,7924,7928,
    7932,7936,7940,7944,7948,7952,7957,7961,7965,7969,
    7973,7977,7981,7985,7989,7994,7998,8002,8006,8010,
    8014,8018,8022,8026,8030,8034,8039,8043,8047,8051,
    8055,8059,8063,8067,8071,8075,8079,8083,8087,8091,
    8095,8099,8104,8108,8112,8116,8120,8124,8128,8132,
    8136,8140,8144,8148,8152,8156,8160,8164,8168,8172,
    8176,8180,8184,8188,8192,8192
};

// :sqrt(2^23/(x*2^16)),xΪеfrom 1 to 1023,տΪQ11ʽ
// Q8룬Q11
const INT16 InvSqrtTab[1026] =
{
    32767,32767,23170,18919,16384,14654,13377,12385,11585,10923,
    10362,9880,9459,9088,8758,8461,8192,7947,7723,7517,
    7327,7151,6986,6833,6689,6554,6426,6306,6193,6085,
    5983,5885,5793,5704,5620,5539,5461,5387,5316,5247,
    5181,5118,5056,4997,4940,4885,4831,4780,4730,4681,
    4634,4588,4544,4501,4459,4418,4379,4340,4303,4266,
    4230,4196,4162,4128,4096,4064,4033,4003,3974,3945,
    3917,3889,3862,3835,3809,3784,3759,3734,3710,3687,
    3664,3641,3619,3597,3575,3554,3533,3513,3493,3473,
    3454,3435,3416,3398,3380,3362,3344,3327,3310,3293,
    3277,3261,3245,3229,3213,3198,3183,3168,3153,3139,
    3124,3110,3096,3083,3069,3056,3042,3029,3017,3004,
    2991,2979,2967,2955,2943,2931,2919,2908,2896,2885,
    2874,2863,2852,2841,2831,2820,2810,2800,2789,2779,
    2769,2760,2750,2740,2731,2721,2712,2703,2694,2684,
    2675,2667,2658,2649,2641,2632,2624,2615,2607,2599,
    2591,2582,2574,2567,2559,2551,2543,2536,2528,2521,
    2513,2506,2499,2491,2484,2477,2470,2463,2456,2449,
    2442,2436,2429,2422,2416,2409,2403,2396,2390,2384,
    2377,2371,2365,2359,2353,2347,2341,2335,2329,2323,
    2317,2311,2306,2300,2294,2289,2283,2278,2272,2267,
    2261,2256,2251,2245,2240,2235,2230,2224,2219,2214,
    2209,2204,2199,2194,2189,2185,2180,2175,2170,2165,
    2161,2156,2151,2147,2142,2138,2133,2129,2124,2120,
    2115,2111,2106,2102,2098,2093,2089,2085,2081,2077,
    2072,2068,2064,2060,2056,2052,2048,2044,2040,2036,
    2032,2028,2024,2021,2017,2013,2009,2005,2002,1998,
    1994,1991,1987,1983,1980,1976,1972,1969,1965,1962,
    1958,1955,1951,1948,1944,1941,1938,1934,1931,1928,
    1924,1921,1918,1914,1911,1908,1905,1901,1898,1895,
    1892,1889,1886,1882,1879,1876,1873,1870,1867,1864,
    1861,1858,1855,1852,1849,1846,1843,1840,1838,1835,
    1832,1829,1826,1823,1820,1818,1815,1812,1809,1807,
    1804,1801,1798,1796,1793,1790,1788,1785,1782,1780,
    1777,1774,1772,1769,1767,1764,1762,1759,1757,1754,
    1752,1749,1747,1744,1742,1739,1737,1734,1732,1729,
    1727,1725,1722,1720,1718,1715,1713,1710,1708,1706,
    1704,1701,1699,1697,1694,1692,1690,1688,1685,1683,
    1681,1679,1677,1674,1672,1670,1668,1666,1664,1661,
    1659,1657,1655,1653,1651,1649,1647,1645,1643,1640,
    1638,1636,1634,1632,1630,1628,1626,1624,1622,1620,
    1618,1616,1614,1612,1610,1609,1607,1605,1603,1601,
    1599,1597,1595,1593,1591,1589,1588,1586,1584,1582,
    1580,1578,1577,1575,1573,1571,1569,1568,1566,1564,
    1562,1560,1559,1557,1555,1553,1552,1550,1548,1546,
    1545,1543,1541,1540,1538,1536,1535,1533,1531,1529,
    1528,1526,1525,1523,1521,1520,1518,1516,1515,1513,
    1511,1510,1508,1507,1505,1503,1502,1500,1499,1497,
    1496,1494,1493,1491,1489,1488,1486,1485,1483,1482,
    1480,1479,1477,1476,1474,1473,1471,1470,1468,1467,
    1465,1464,1463,1461,1460,1458,1457,1455,1454,1452,
    1451,1450,1448,1447,1445,1444,1443,1441,1440,1438,
    1437,1436,1434,1433,1431,1430,1429,1427,1426,1425,
    1423,1422,1421,1419,1418,1417,1415,1414,1413,1411,
    1410,1409,1408,1406,1405,1404,1402,1401,1400,1399,
    1397,1396,1395,1393,1392,1391,1390,1388,1387,1386,
    1385,1383,1382,1381,1380,1379,1377,1376,1375,1374,
    1373,1371,1370,1369,1368,1367,1365,1364,1363,1362,
    1361,1359,1358,1357,1356,1355,1354,1352,1351,1350,
    1349,1348,1347,1346,1344,1343,1342,1341,1340,1339,
    1338,1337,1336,1334,1333,1332,1331,1330,1329,1328,
    1327,1326,1325,1323,1322,1321,1320,1319,1318,1317,
    1316,1315,1314,1313,1312,1311,1310,1309,1308,1307,
    1306,1304,1303,1302,1301,1300,1299,1298,1297,1296,
    1295,1294,1293,1292,1291,1290,1289,1288,1287,1286,
    1285,1284,1283,1282,1281,1280,1279,1278,1277,1276,
    1275,1275,1274,1273,1272,1271,1270,1269,1268,1267,
    1266,1265,1264,1263,1262,1261,1260,1259,1258,1258,
    1257,1256,1255,1254,1253,1252,1251,1250,1249,1248,
    1247,1247,1246,1245,1244,1243,1242,1241,1240,1239,
    1239,1238,1237,1236,1235,1234,1233,1232,1231,1231,
    1230,1229,1228,1227,1226,1225,1225,1224,1223,1222,
    1221,1220,1219,1219,1218,1217,1216,1215,1214,1214,
    1213,1212,1211,1210,1209,1209,1208,1207,1206,1205,
    1205,1204,1203,1202,1201,1201,1200,1199,1198,1197,
    1197,1196,1195,1194,1193,1193,1192,1191,1190,1189,
    1189,1188,1187,1186,1186,1185,1184,1183,1182,1182,
    1181,1180,1179,1179,1178,1177,1176,1176,1175,1174,
    1173,1173,1172,1171,1170,1170,1169,1168,1167,1167,
    1166,1165,1164,1164,1163,1162,1161,1161,1160,1159,
    1159,1158,1157,1156,1156,1155,1154,1153,1153,1152,
    1151,1151,1150,1149,1149,1148,1147,1146,1146,1145,
    1144,1144,1143,1142,1142,1141,1140,1139,1139,1138,
    1137,1137,1136,1135,1135,1134,1133,1133,1132,1131,
    1131,1130,1129,1129,1128,1127,1127,1126,1125,1125,
    1124,1123,1123,1122,1121,1121,1120,1119,1119,1118,
    1117,1117,1116,1115,1115,1114,1114,1113,1112,1112,
    1111,1110,1110,1109,1108,1108,1107,1106,1106,1105,
    1105,1104,1103,1103,1102,1101,1101,1100,1100,1099,
    1098,1098,1097,1097,1096,1095,1095,1094,1093,1093,
    1092,1092,1091,1090,1090,1089,1089,1088,1087,1087,
    1086,1086,1085,1084,1084,1083,1083,1082,1082,1081,
    1080,1080,1079,1079,1078,1077,1077,1076,1076,1075,
    1075,1074,1073,1073,1072,1072,1071,1070,1070,1069,
    1069,1068,1068,1067,1067,1066,1065,1065,1064,1064,
    1063,1063,1062,1061,1061,1060,1060,1059,1059,1058,
    1058,1057,1056,1056,1055,1055,1054,1054,1053,1053,
    1052,1052,1051,1050,1050,1049,1049,1048,1048,1047,
    1047,1046,1046,1045,1045,1044,1044,1043,1042,1042,
    1041,1041,1040,1040,1039,1039,1038,1038,1037,1037,
    1036,1036,1035,1035,1034,1034,1033,1033,1032,1032,
    1031,1031,1030,1030,1029,1029,1028,1028,1027,1027,
    1026,1026,1025,1025,1024,1024
};

// ڵ
// Q0(125@80Hz~333@30Hz)Q15
const INT16 InvPointCntTab[209] =
{
    262,260,258,256,254,252,250,248,246,245,
    243,241,239,237,236,234,232,231,229,228,
    226,224,223,221,220,218,217,216,214,213,
    211,210,209,207,206,205,204,202,201,200,
    199,197,196,195,194,193,192,191,189,188,
    187,186,185,184,183,182,181,180,179,178,
    177,176,175,174,173,172,172,171,170,169,
    168,167,166,165,165,164,163,162,161,161,
    160,159,158,158,157,156,155,155,154,153,
    152,152,151,150,150,149,148,148,147,146,
    146,145,144,144,143,142,142,141,141,140,
    139,139,138,138,137,137,136,135,135,134,
    134,133,133,132,132,131,131,130,130,129,
    129,128,128,127,127,126,126,125,125,124,
    124,123,123,122,122,121,121,120,120,120,
    119,119,118,118,117,117,117,116,116,115,
    115,115,114,114,113,113,113,112,112,111,
    111,111,110,110,110,109,109,109,108,108,
    107,107,107,106,106,106,105,105,105,104,
    104,104,103,103,103,102,102,102,101,101,
    101,101,100,100,100,99,99,99,98
};


extern "C"
{
    INT16 abs(INT16);
    INT32 labs(INT32);
}


//---------------------------------------

INT16   igap(INT16 curr_value, const FLAG_TABLE *f_table, INT16 old_flag);

UINT16 u16_FPGA_Flash_CANInit;

#endif

//===========================================================================
// End of file.
//===========================================================================

