#include "WatchDogDrv.h"



// This function resets the watchdog timer.
void Class_WatchDogDrv::Drv_KickDog(void)
{
    EALLOW;
    WdRegs.WDKEY.bit.WDKEY = 0x0055;
    WdRegs.WDKEY.bit.WDKEY = 0x00AA;
    EDIS;
}


// This function disables the watchdog timer.
void Class_WatchDogDrv::Drv_DisableDog(void)
{
	volatile Uint16 tmp;
    EALLOW;
    //Grab the clock config so we don't clobber it
    tmp = WdRegs.WDCR.all & 0x0007;
    WdRegs.WDCR.all = 0x0068 | tmp;
    EDIS;

}

// This function enables the watchdog timer.
void Class_WatchDogDrv::Drv_EnableDog(void)
{
// Enable the watchdog
	EALLOW;
	WdRegs.WDCR.all = 0x0028;
	EDIS;

}


//============================================================
// End of file.
//============================================================
